import 'dart:math';

import 'package:flutter/material.dart';

import '../../config/app_colors.dart';

class GraphPainter extends CustomPainter {
  const GraphPainter();

  double random(double max) {
    return 0.1 * max + Random().nextDouble() * max * 0.8;
  }

  Color getRandomColor() {
    const List<Color> availableColors = [
      AppColors.contentColorCyan,
      AppColors.contentColorGreen,
      AppColors.contentColorOrange,
      AppColors.contentColorPurple,
    ];

    return availableColors[Random().nextInt(availableColors.length)];
  }

  @override
  void paint(Canvas canvas, Size size) {
    // Fill background
    final paintBackground = Paint();
    paintBackground.color = Colors.black;
    paintBackground.style = PaintingStyle.fill;

    final Rect rectBackground = Rect.fromPoints(Offset(0, 0), Offset(size.width, size.height));
    canvas.drawRect(rectBackground, paintBackground);

    // Draw some lines
    Paint paintLine = Paint();
    paintLine.style = PaintingStyle.fill;
    paintLine.strokeWidth = 2.0;

    int linesCount = 300;
    for (int i = 0; i < linesCount; i++) {
      paintLine.color = getRandomColor();

      Offset lineStart = Offset(random(size.width), random(size.height));
      Offset lineStop = Offset(random(size.width), random(size.height));
      canvas.drawLine(lineStart, lineStop, paintLine);
    }
  }

  @override
  bool shouldRepaint(CustomPainter oldDelegate) {
    return false;
  }
}
